(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *  Copyright (C) 2004-2006 Ekrem "ECoder" KOAK                        *
 *  Mail: ekremkocak@hotmail.com                                                 *
 *                                                                           *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)

unit B2C2SDK;

interface

uses
  Windows, directshow9;
const
  CLSID_B2C2MPEG2Filter: TGuid = '{E82536A0-94DA-11d2-A463-00A0C95D308D}';
  IID_IB2C2MPEG2TunerCtrl: TGuid = '{D875D4A9-0749-4fe8-ADB9-CC13F9B3DD45}';
  IID_IB2C2MPEG2AVCtrl: TGuid = '{295950B0-696D-4a04-9EE3-C031A0BFBEDE}';

  IID_IB2C2MPEG2TunerCtrl2: TGuid = '{CD900832-50DF-4f8f-882D-1C358F90B3F2}';
  IID_IB2C2MPEG2DataCtrl: TGuid = '{7F35C560-08B9-11d5-A469-00D0D7B2C2D7}';
  IID_IB2C2MPEG2DataCtrl2: TGuid = '{B0666B7C-8C7D-4c20-BB9B-4A7FE0F313A8}';
  IID_IB2C2MPEG2DataCtrl3: TGuid = '{E2857B5B-84E7-48b7-B842-4EF5E175F315}';
  IID_IB2C2MPEG2DataCtrl4:TGUID='{5927DB1C-B2AC-441f-89A7-C61194D15392}';
  IID_IB2C2MPEG2DataCtrl5:TGUID='{B5AFA7F3-2FBC-4d66-AD9C-FF8616141C26}';

  IID_IB2C2MPEG2AVCtrl2: TGuid = '{9C0563CE-2EF7-4568-A297-88C7BB824075}';
  IID_IB2C2MPEG2DataPin: TGuid = '{76604DC1-9052-4483-B57B-E3B353E45720}';
  IID_IB2C2MPEG2PvrCtrl: TGuid = '{A306AF1C-51D9-496d-9E7A-1CFE28F51FAD}';
  B2C2_DEVICE_ID = 'dcdvb:device:b2c2:';
type
  Float = Single;
  MPEG2_VIDEO_INFO = record
    wHSize, // video data horizontal size in pixels
    wVSize: Word; // video data vertical size in pixels
    bAspectRatio, bFrameRate: Byte;
  end;

  TVideoCallback = function(out Info: MPEG2_VIDEO_INFO): HResult; stdcall;

  tMacAddressList = record
    lCount: DWord;
    MacAddr: array[0..31, 0..5] of byte;
  end;

  TTunerCapabilities = record
    tTunerModulation: DWord; //??
    dwConstellationSupported,
      dwFECSupported,
      dwMinTransponderFreqInKHz,
      dwMaxTransponderFreqInKHz,
      dwMinTunerFreqInKHz,
      dwMaxTunerFreqInKHz,
      dwMinSymbolRateInBaud,
      dwMaxSymbolRateInBaud,
      bAutoSymbolRate,
      dwPerformanceMonitoring: DWord;
  end;

  IB2C2MPEG2TunerCtrl = interface(IUnknown)
    ['{D875D4A9-0749-4fe8-ADB9-CC13F9B3DD45}']
    function SetFrequency(dwSetFrequency: DWord): HResult; stdcall;
    function SetSymbolRate(dwSetSymbolRate: DWord): HResult; stdcall;
    function SetLnbFrequency(dwSetLnbFrequency: DWord): HResult; stdcall;
    function SetFec(dwSetFec: DWord): HResult; stdcall;
    function SetPolarity(dwSetPolarity: DWord): HResult; stdcall;
    function SetLnbKHz(dwSetLnbKHz: DWord): HResult; stdcall;
    function SetDiseqc(dwSetDiseqc: DWord): HResult; stdcall;
    function SetModulation(dwSetModulation: DWord): HResult; stdcall;
    function Initialize: Hresult; stdcall;
    function SetTunerStatus: HResult; stdcall;
    function CheckLock: HResult; stdcall;
    function GetTunerCapabilities(out dwTuner: tTunerCapabilities; out plSize:
      DWord): HResult; stdcall;

    // Terrestrial (ATSC)

    function GetFrequency(out plFrequencyMHz: DWord): HResult; stdcall;
    function GetSymbolRate(out plGetSymbolRate: DWord): HResult; stdcall;
    function GetModulation(out plGetModulation: DWord): HResult; stdcall;
    function GetSignalStrength(out plSignalStrength: DWord): HResult; stdcall;
    function GetSignalLevel(out plSignalLevel: Float): HResult; stdcall;

    function GetSNR(out plSNR: Float): HResult; stdcall;
    function GetPreErrorCorrectionBER(out plError: Float; dwVal: boolean):
      HResult; stdcall;

    function GetUncorrectedBlocks(out pluncorrected: Float): HResult; stdcall;
    function GetTotalBlocks(out dwTotal: DWord): HResult; stdcall;
    function GetChannel(out dwChannel: DWord): HResult; stdcall;
    function SetChannel(dwChannel: DWord): HResult; stdcall;
  end;
  IB2C2MPEG2TunerCtrl2 = interface(IB2C2MPEG2TunerCtrl)
    ['{CD900832-50DF-4f8f-882D-1C358F90B3F2}']
    function SetTunerStatusEx(dwTunerStatusEx: DWord): HResult; stdcall;
    function SetFrequencyKHz(dwSetFrequency: DWord): HResult; stdcall;
    // Terrestrial DVB only

    function SetGuardInterval(dwSetGuardInterval: DWord): Hresult; stdcall;
    function GetGuardInterval(out dwGetGuardInterval: DWord): HResult; stdcall;
    function GetFec(out plFec: DWord): HResult; stdcall;
    function GetPolarity(out plPolarity: DWord): Hresult; stdcall;
    function GetDiseqc(out plDiseqc: DWord): HResult; stdcall;
    function GetLnbKHz(out plLnbKHz: DWord): HResult; stdcall;
    function GetLnbFrequency(out plFrequencyMHz: DWord): HResult; stdcall;
    function GetCorrectedBlocks(out plCorrectedBlocks: DWord): HResult; stdcall;
    function GetSignalQuality(out pdwSignalQuality: DWord): HResult; stdcall;
  end;

  IB2C2MPEG2DataCtrl = interface(IUnknown)
    ['{7F35C560-08B9-11d5-A469-00D0D7B2C2D7}']
    function GetMaxPIDCount(out dwGetMaxPIDCount: DWord): HResult; stdcall;
    function AddPIDs(dwAddPIDs: DWord; OutAddPid: Pointer): HResult; stdcall;
    function DeletePIDs(dwDeletePIDs: DWord; OutDeletePIDs: Pointer): HResult;
      stdcall;
    // IP methods

    function GetMaxIpPIDCount(out dwMaxIP: Dword): HResult; stdcall;
    function AddIpPIDs(size: DWord; plPIDArray: Pointer): HResult; stdcall;
      {PIDArray array?}
    function DeleteIpPIDs(size: DWord; plPIDArray: pointer): HResult; stdcall;

    function GetIpPIDs(out plCount: DWord; glPIDArray: Pointer): HResult;
      stdcall;

    // All protocols

    function PurgeGlobalPIDs: Hresult; stdcall;
    function GetMaxGlobalPIDCount(out glMaxPIDCount: DWord): Hresult; stdcall;
    function GetGlobalPIDs(out plCount: DWord; plPIDArray: Pointer): HResult;
      stdcall;
    function ResetDataReceptionStats: Hresult; stdcall;
    function GetDataReceptionStats(out plIPQuality, plTSQuality: DWord): HResult;
      stdcall;
  end;
  IB2C2MPEG2DataCtrl2 = interface(IB2C2MPEG2DataCtrl)
    ['{B0666B7C-8C7D-4c20-BB9B-4A7FE0F313A8}']
    function AddPIDsToPin(out plNumPID: DWord; plPIDArray: PInteger;
      lDataPinIndex: DWord): HResult; stdcall;
    function DeletePIDsFromPin(lNumPID: DWord; plPIDs: Pointer; lDataPinIndex:
      DWord): HResult; stdcall;
  end;

  IB2C2MPEG2DataCtrl3 = interface(IB2C2MPEG2DataCtrl2) // LINUX
    ['{E2857B5B-84E7-48b7-B842-4EF5E175F315}']
    function AddTsPIDs(lCount: DWord;plPIDArray:PInteger): HResult; stdcall;
    function DeleteTsPIDs(lCount: DWord;plPIDArray: PInteger): HResult;
      stdcall;
    function GetTsState(out plOpen: DWord; out plRunning: DWord; out plCount:
      DWord; out plPIDArray: DWord): HResult; stdcall;
    function GetIpState(out plOpen: DWord; out plRunning: DWord; out plCount:
      DWord; out plPIDArray: DWord): HResult; stdcall;
    function GetReceivedDataIp(out pllDataRcv: int64; out pllIpRcv: int64):
      Hresult; stdcall;
    function AddMulticastMacAddress(out pMacAddrList: tMacAddressList): Hresult;
      stdcall;
    function GetMulticastMacAddressList(out pMacAddrList: tMacAddressList):
      Hresult; stdcall;
    function DeleteMulticastMacAddress(out pMacAddrList: tMacAddressList):
      Hresult; stdcall;
    function SetUnicastMacAddress(pMacAddr: PByte): HResult; stdcall;
    function GetUnicastMacAddress(pMacAddr: PByte): HResult; stdcall;
    function RestoreUnicastMacAddress: HResult; stdcall;
  end;

 IB2C2MPEG2DataCtrl4 = interface(IB2C2MPEG2DataCtrl3)
    ['{5927DB1C-B2AC-441f-89A7-C61194D15392}']
    function GetHardwareMacAddress(pHwMacAddr:PChar):HResult; stdcall;
    function SetTableId(Value:Integer):HResult; stdcall;
    function GetTableId(var Value:Integer):HResult; stdcall;
	  // Key Methods
    function GetKeyCount(var plTotal:Integer;var plPidTscKeys:Integer;var plPidKeys:Integer;var plGlobalKey:Integer):HResult; stdcall;
    function GetKeysInUse(var plCount:Integer;var plTypeArray:PInteger;var plPidArray:PInteger):HResult; stdcall;
    function AddKey(lType:Integer;lPid:Integer;pKey:PChar;lKeyLength:Integer):HResult; stdcall;
    function DeleteKey(lType:Integer;lPid:Integer):HResult; stdcall;
    function PurgeKeys:HResult; stdcall;
  end;

  IB2C2MPEG2DataCtrl5 = interface(IB2C2MPEG2DataCtrl4)
    ['{B5AFA7F3-2FBC-4d66-AD9C-FF8616141C26}']
    function SetCallbackForTransportStream(pvCallBack:Pointer):HResult; stdcall;
  end;

  IB2C2MPEG2DataPin = interface(IUnknown)
    ['{76604DC1-9052-4483-B57B-E3B353E45720}']
    //return the pin index
    function GetDataPinIndex(out dwDataPinIndex: DWord): Hresult; stdcall;
    //add PIDs to this pin
    //Parameter:   a PID array, a pointer to long as number of PIDs in the array
    //Return:      FAILED() -- non added, plNumPID contains the number of PIDs added
    function AddDataPIDs(out plNumPID: DWord; plPIDs: pinteger): Hresult;
      stdcall;
    //delete PIDs to this pin
    //Parameter:   a PID array, number of PIDs in the array
    //Return:      FAILED() -- non deleted
    function DeleteDataPIDs(dwPIDCount: DWord; out dwPIDArray: DWord): Hresult;
      stdcall;
  end;

  IB2C2MPEG2AVCtrl = interface(IUnknown)
    ['{295950B0-696D-4a04-9EE3-C031A0BFBEDE}']
    function SetAudioVideoPIDs(dwAPID, dwVPid: DWord): HResult; stdcall;
  end;

  IB2C2MPEG2AVCtrl2 = interface(IB2C2MPEG2AVCtrl)
    ['{9C0563CE-2EF7-4568-A297-88C7BB824075}']
    function SetCallbackForVideoMode(Func: TVideoCallback): hresult; stdcall;
    function DeleteAudioVideoPIDs(bAudioPID, bVideoPID: DWord): hresult;
      stdcall;
     function GetAudioVideoState(var plAudioOpen:Integer;var plVideoOpen:Integer;
      var plAudioRunning:Integer;var plVideoRunning:Integer;var plAudioPID:Integer;
      var plVideoPID:Integer):HResult; stdcall;
  end;

  IB2C2MPEG2PvrCtrl = interface(IUnknown)
    function AddPids(lPids: Word; palPids: Pointer): Hresult; stdcall;
    function DeletePids: Hresult; stdcall;
    function SetCommand(eCommand: DWord; pvData: Pointer): Hresult; stdcall;
    function GetStatistics(eStatistics: DWord; out pvData: int64): Hresult; stdcall;
    function SetCallback(pvCallback: Pointer): Hresult; stdcall;
    function SetPosition(ePosition: DWORD; iPositionData: int64): Hresult; stdcall;
  end;


const
  TUNER_CABLE = 0;
  TUNER_SATELLITE = 1;

  FEC_1_2 = 1;
  FEC_2_3 = 2;
  FEC_3_4 = 3;
  FEC_5_6 = 4;
  FEC_7_8 = 5;
  FEC_AUTO = 6;

  POL_HORI = 0;
  POL_VER = 1;
  POLARITY_LNB_NO_POWER = 10;
  LNB_NONE = 0;
  LNB_22Khz = 1;
  LNB_33Khz = 2;
  LNB_44Khz = 3;

  	LNB_SELECTION_0 = 0;
	LNB_SELECTION_22=1;
	LNB_SELECTION_33=2;
	LNB_SELECTION_44=3;

  DiseqC_None = 0;
  DiseqC_SimpleA = 1;
  DiseqC_SimpleB = 2;
  DiseqC_PosA_OptA = 3;
  DiseqC_PosB_OptA = 4;
  DiseqC_PosA_OptB = 5;
  DiseqC_PosB_OptB = 6;

  QAM_4 = 2;
  QAM_16 = 3;
  QAM_32 = 4;
  QAM_64 = 5;
  QAM_128 = 6;
  QAM_256 = 7;

  PVR_ENABLE = 0;
  PVR_RECORD_FILENAME = 1;
  PVR_AUTO_DELETE_RECORD_FILE = 2;
  PVR_AUTO_RECORD_WITH_PLAY = 3;
  PVR_FILE_START = 4;
  PVR_RECORD = 5;

  PVR_PLAY_FILE_EOF = 10;
  PVR_RECORD_FILE_ERROR = 11;

  PVR_START_POSITION = 0;
  PVR_END_POSITION = 1;
  PVR_RELATIVE_POSITION = 2;
  PVR_ABSOLUTE_POSITION = 3;

  PVR_RECORD_FILE_SIZE = 0;
  PVR_PLAY_FILE_POSITION = 1;


   BER_SUPPORTED:Integer=1;				// BER reporting via GetPreErrorCorrectionBER ()
  BLOCK_COUNT_SUPPORTED:Integer=1 shl 1;		// Block count report via GetTotalBlocks ()
  CORRECTED_BLOCK_COUNT_SUPPORTED:Integer=1 shl 2;		// Corrected block count via GetCorrectedBlocks
  UNCORRECTED_BLOCK_COUNT_SUPPORTED:Integer=(1 shl 3);		// Uncorrected block count via GetUncorrectedBlocks
  SNR_SUPPORTED:Integer=(1 shl 4);		// SNR via GetSNR ()
  SIGNAL_STRENGTH_SUPPORTED:Integer=(1 shl 5);		// Signal strength via GetSignalStrength()
  SIGNAL_QUALITY_SUPPORTED:Integer=(1 shl 6);


implementation


end.

