
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *  Copyright (C) 2004-2006 Ekrem "ECoder" KOAK                        *
 *  Mail: ekremkocak@hotmail.com                                                 *
 *                                                                           *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)

unit SkyStar2;

interface
 uses
 Windows, SysUtils, Classes,Controls,ExtCtrls ,Messages,B2C2SDK,directshow9,
 DSUtil,ActiveX,ComObj,PushSource;

  const
  MPEG1AudioFormat: array[0..39] of Byte=(
    $50, $00, $02, $00, $80, $BB, $00, $00,
    $00, $7D, $00, $00, $00, $03, $00, $00,
    $16, $00, $02, $00, $00, $E8, $03, $00,
    $01, $00, $01, $00, $01, $00, $1C, $00,
    $00, $00, $00, $00, $00, $00, $00, $00 );

  Mpeg2ProgramVideo: array[0..217] of Byte=(
    $00, $00, $00, $00,                         //  .hdr.rcSource.left              = $00000000
    $00, $00, $00, $00,                         //  .hdr.rcSource.top               = $00000000
    $D0, $02, $00, $00,                         //  .hdr.rcSource.right             = $000002d0
    $E0, $01, $00, $00,                         //  .hdr.rcSource.bottom            = $000001e0
    $00, $00, $00, $00,                         //  .hdr.rcTarget.left              = $00000000
    $00, $00, $00, $00,                         //  .hdr.rcTarget.top               = $00000000
    $00, $00, $00, $00,                         //  .hdr.rcTarget.right             = $00000000
    $00, $00, $00, $00,                         //  .hdr.rcTarget.bottom            = $00000000
    $00, $09, $3D, $00,                         //  .hdr.dwBitRate                  = $003d0900
    $00, $00, $00, $00,                         //  .hdr.dwBitErrorRate             = $00000000
    $63, $17, $05, $00, $00, $00, $00, $00,     //  .hdr.AvgTimePerFrame            = $0000000000051763
    $00, $00, $00, $00,                         //  .hdr.dwInterlaceFlags           = $00000000
    $00, $00, $00, $00,                         //  .hdr.dwCopyProtectFlags         = $00000000
    $04, $00, $00, $00,                         //  .hdr.dwPictAspectRatioX         = $00000004
    $03, $00, $00, $00,                         //  .hdr.dwPictAspectRatioY         = $00000003
    $00, $00, $00, $00,                         //  .hdr.dwReserved1                = $00000000
    $00, $00, $00, $00,                         //  .hdr.dwReserved2                = $00000000
    $28, $00, $00, $00,                         //  .hdr.bmiHeader.biSize           = $00000028
    $D0, $02, $00, $00,                         //  .hdr.bmiHeader.biWidth          = $000002d0
    $E0, $01, $00, $00,                         //  .hdr.bmiHeader.biHeight         = $00000000
    $00, $00,                                     //  .hdr.bmiHeader.biPlanes         = $0000
    $00, $00,                                     //  .hdr.bmiHeader.biBitCount       = $0000
    $00, $00, $00, $00,                         //  .hdr.bmiHeader.biCompression    = $00000000
    $00, $00, $00, $00,                         //  .hdr.bmiHeader.biSizeImage      = $00000000
    $D0, $07, $00, $00,                         //  .hdr.bmiHeader.biXPelsPerMeter  = $000007d0
    $27, $CF, $00, $00,                         //  .hdr.bmiHeader.biYPelsPerMeter  = $0000cf27
    $00, $00, $00, $00,                         //  .hdr.bmiHeader.biClrUsed        = $00000000
    $00, $00, $00, $00,                         //  .hdr.bmiHeader.biClrImportant   = $00000000
    $98, $F4, $06, $00,                         //  .dwStartTimeCode                = $0006f498
    $56, $00, $00, $00,                         //  .cbSequenceHeader               = $00000056
    $02, $00, $00, $00,                         //  .dwProfile                      = $00000002
    $02, $00, $00, $00,                         //  .dwLevel                        = $00000002
    $00, $00, $00, $00,                         //  .Flags                          = $00000000
                                                //  .dwSequenceHeader [1]
    $00, $00, $01, $B3, $2D, $01, $E0, $24,
    $09, $C4, $23, $81, $10, $11, $11, $12,
    $12, $12, $13, $13, $13, $13, $14, $14, 
    $14, $14, $14, $15, $15, $15, $15, $15,
    $15, $16, $16, $16, $16, $16, $16, $16,
    $17, $17, $17, $17, $17, $17, $17, $17, 
    $18, $18, $18, $19, $18, $18, $18, $19, 
    $1A, $1A, $1A, $1A, $19, $1B, $1B, $1B,
    $1B, $1B, $1C, $1C, $1C, $1C, $1E, $1E,
    $1E, $1F, $1F, $21, $00, $00, $01, $B5,
    $14, $82, $00, $01, $00, $00 );



 const
  MAX_FILTER_COUNT = 39;
  BUF_SIZE = 4096;
  PACKET_SIZE =188;
  PACKET_NUM =1;

  type
   CSampleGrabberCB = class(TInterfacedObject,ISampleGrabberCB)
        function BufferCB(SampleTime: Double; pBuffer: PByte; BufferLen: longint): HResult; stdcall;
        function SampleCB(SampleTime: Double; pSample: IMediaSample): HResult; stdcall;

    end;

 type
  LPCB_STREAMHOOK = procedure(FilterID: Dword;Len: Cardinal;Buf: PByteArray); stdcall;

 type
  TFilter =record
    Active: Boolean;
    Pid:integer;
    CallBackFunction: LPCB_STREAMHOOK;
  end;

 var
    GraphBuilder       : IGraphBuilder        = nil;
    MediaControl       : IMediaControl        = nil;
    VideoWindow        : IVideoWindow        = nil;
    B2C2MPEG2Filter    : IBaseFilter          = nil;
    B2C2MPEG2TunerCtrl : IB2C2MPEG2TunerCtrl2 = nil;
    B2C2MPEG2DataCtrl  : IB2C2MPEG2DataCtrl2 = nil;
    RotEntry           : integer;
    Signal_Strengths_Sup: BOOL = False;
    Signal_Quality_Sup: BOOL = False;
    Signal_BER_Sup: BOOL = False;

    Fcount              :cardinal = 1;
    Filters:array[0..MAX_FILTER_COUNT-1] of TFilter;

   
     DeMultiplexerFilter: IBaseFilter          = nil;
     AudioRender : IBaseFilter                 = nil;
     VideoDecoder :IBaseFilter                 = nil;
     AudioDecoder :IBaseFilter                 = nil;
     VideoPin           : IPin                 = nil;
     AudioPin           : IPin                 = nil;
     VideoPid           :integer ;
     AudioPid           :integer ;

     VideoStreamMap: IMPEG2PIDMap;
     AudioStreamMap: IMPEG2PIDMap;
     ActiveAudioPid: Integer;
     ActiveVideoPid: Integer;

     DestinationRect: TRect;

     FCB:CSampleGrabberCB= nil ;
     FSample:IBaseFilter = nil;
     MediaType:  TAMMediaType;
     FSampleGrabber :ISampleGrabber= nil;

    PushSourceInterface:ITSPushSource    = nil;
    PushSourceFilter   :IBaseFilter           = nil;

    function StartDVB(Owner:HWND;Devices: Integer; var ErrorMessage: string): BOOL; stdcall;
    procedure StopDVB();stdcall;
    function SetChannel(DiseqC:DWORD;Freq:DWORD; smyb: DWORD; pol: DWORD;fec: DWORD ; lof1 :DWORD; lof2 :DWORD; lofsw :DWORD): BOOL;stdcall;
    function SetFilter(wPID:Word;StreamHook: LPCB_STREAMHOOK): Dword; stdcall;
    function DelFilter(FilterID: Dword): BOOL;stdcall;
    function GetTunerStatus(Level, Quality: PByte): Bool; stdcall;


   procedure Mpeg2DemultiplexerSetNewPids(VideoPid: Integer; AudioPid: Integer);

implementation

  Uses Unit1;

function  CSampleGrabberCB.BufferCB(SampleTime: Double; pBuffer:pBYTE; BufferLen: longint): HResult; stdcall;
begin
 result :=0;
end;

function  CSampleGrabberCB.SampleCB(SampleTime: Double; pSample: IMediaSample): HResult; stdcall;
 var
  pbData: PBYTE;
  tStart, tStop: TREFERENCETIME;
  Pid:Word;
  i:integer;
begin
   pSample.GetTime(tStart,tStop);
   pSample.GetPointer(pbData);
 if Assigned(pbData) and (pSample.GetActualDataLength > 0)then
  begin

    Pid :=(PByteArray(pbData)[1] and $1F shl 8) or PByteArray(pbData)[2];
    for i:=0 to MAX_FILTER_COUNT-1 do
     if (Filters[i].Active)and(Filters[i].PID=Pid)  then
     begin
       Filters[i].CallBackFunction(i+1,pSample.GetActualDataLength,PByteArray(pbData));
       result :=S_OK;
       exit;
     end;

  end;
 result :=S_OK;
end;



function StartDVB(Owner:HWND;Devices: Integer; var ErrorMessage: string): BOOL; stdcall;
var

 TunerCaps: TTunerCapabilities;
 TunerCapsSize: dword;

 VideoType   : AM_MEDIA_Type;
 AudioType   : AM_MEDIA_Type;
 MPEG2DemultiplexerInterface: IMPEG2Demultiplexer;

 OutPin: IPin;
 PinsEnum: IEnumPins;
 Pins: IPin;
 PinsInfo: TPinInfo;
begin

   if  CoCreateInstance(CLSID_FilterGraph, nil, CLSCTX_INPROC, IID_IGraphBuilder, GraphBuilder) = S_OK then
   begin
     AddGraphToRot( GraphBuilder, RotEntry);
     GraphBuilder.QueryInterface(IID_IMediaControl, MediaControl);
     GraphBuilder.QueryInterface(IID_IVideoWindow,VideoWindow);

      if  CoCreateInstance(CLSID_B2C2MPEG2Filter, nil, CLSCTX_INPROC_SERVER, IID_IBaseFilter, B2C2MPEG2Filter)= S_OK then
        begin
         GraphBuilder.AddFilter( B2C2MPEG2Filter, StringToOleStr('B2C2Filter'));
         B2C2MPEG2Filter.QueryInterface(IID_IB2C2MPEG2TunerCtrl2, B2C2MPEG2TunerCtrl);
         B2C2MPEG2Filter.QueryInterface(IID_IB2C2MPEG2DataCtrl2, B2C2MPEG2DataCtrl);
         B2C2MPEG2TunerCtrl.Initialize;
         B2C2MPEG2TunerCtrl.CheckLock;
         TunerCapsSize:=SizeOf(TTunerCapabilities);
         B2C2MPEG2TunerCtrl.GetTunerCapabilities(tunerCaps,TunerCapsSize);
         Signal_Quality_Sup :=tunerCaps.dwPerformanceMonitoring and SIGNAL_QUALITY_SUPPORTED >0;
         Signal_Strengths_Sup :=tunerCaps.dwPerformanceMonitoring and SIGNAL_STRENGTH_SUPPORTED>0;
         Signal_BER_Sup :=tunerCaps.dwPerformanceMonitoring and BER_SUPPORTED>0;
        end;
        

        PushSourceFilter := TSPushSource.Create();
        if PushSourceFilter <> nil then
        begin
         GraphBuilder.AddFilter(PushSourceFilter, 'PushSource Filter');
         PushSourceFilter.QueryInterface(IID_ITSPushSource, PushSourceInterface);
        end;


   if CoCreateInstance(CLSID_MPEG2Demultiplexer, nil, CLSCTX_INPROC,IID_IBaseFilter, DeMultiplexerFilter)= S_OK then
     begin
       GraphBuilder.AddFilter( DeMultiplexerFilter, 'MPEG-2 Demultiplexer');
       DeMultiplexerFilter.QueryInterface(IID_IMpeg2Demultiplexer, MPEG2DemultiplexerInterface);
         VideoType.majortype := MEDIATYPE_Video;
         VideoType.subtype := MEDIASUBTYPE_MPEG2_VIDEO;
         VideoType.bFixedSizeSamples := TRUE;
         VideoType.bTemporalCompression := FALSE;
         VideoType.formattype :=FORMAT_MPEG2Video;
         VideoType.pUnk := nil;
         VideoType.cbFormat := sizeof( Mpeg2ProgramVideo );
         VideoType.pbFormat := @Mpeg2ProgramVideo;
     MPEG2DemultiplexerInterface.CreateOutputPin(VideoType, 'Video', VideoPin);
         AudioType.majortype := MEDIATYPE_Audio;
         AudioType.subtype :=  MEDIASUBTYPE_MPEG2_AUDIO;  // MEDIASUBTYPE_MPEG1Audio;
         AudioType.bFixedSizeSamples := TRUE;
         AudioType.bTemporalCompression := False;
         AudioType.formattype :=FORMAT_WaveFormatEx;// FORMAT_MPEG2Audio;
         AudioType.pUnk := nil;
         AudioType.cbFormat := sizeof( MPEG1AudioFormat );
         AudioType.pbFormat := @MPEG1AudioFormat;
     MPEG2DemultiplexerInterface.CreateOutputPin(AudioType, 'Audio', AudioPin);
     MPEG2DemultiplexerInterface := nil;
   end;

        if CoCreateInstance(CLSID_SampleGrabber,nil, CLSCTX_INPROC,IID_IBaseFilter,FSample)= S_OK then
         begin
        GraphBuilder.AddFilter(FSample,'Grabber');
        FSample.QueryInterface(IID_ISampleGrabber,FSampleGrabber);

      {  ZeroMemory(@MediaType, sizeof(TAMMediaType));
        MediaType.majortype :=MEDIATYPE_Stream;
        MediaType.SubType := MEDIASUBTYPE_MPEG2_TRANSPORT;
        MediaType.FormatType :=GUID_NULL;
        MediaType.lSampleSize := 188;

        FSampleGrabber.SetMediaType(MediaType);  }
        FSampleGrabber.SetOneShot(false);
        FSampleGrabber.SetBufferSamples(true);
        FCB:=CSampleGrabberCB.Create();
        FSampleGrabber.SetCallback(FCB,0);
       end;



       B2C2MPEG2Filter.EnumPins(PinsEnum);
       PinsEnum.Reset;
        while PinsEnum.Next(1, Pins, nil) = S_OK do
        begin
          Pins.QueryPinInfo(PinsInfo);
          PinsInfo.pFilter := nil;
        if UpperCase(PinsInfo.achName) = 'DATA 0' then
           outPin := Pins;
        end;
        Pins := nil;
        PinsEnum := nil;

   GraphBuilder.ConnectDirect(GetOutPin( PushSourceFilter, 0), GetInPin(DeMultiplexerFilter, 0), nil);
   GraphBuilder.ConnectDirect(outPin, GetInPin(FSample, 0), nil);

   GraphBuilder.Render(VideoPin);
   GraphBuilder.Render(AudioPin);
  
   VideoWindow.put_Owner(Form1.Panel1.Handle);
   VideoWindow.put_MessageDrain(Form1.Panel1.Handle);
   VideoWindow.put_WindowStyle(WS_CHILD or WS_CLIPSIBLINGS or WS_CLIPCHILDREN);
   VideoWindow.SetWindowPosition(0,0,Form1.Panel1.Width,Form1.Panel1.Height);


 if Assigned(DemultiplexerFilter) then
  begin
  DemultiplexerFilter.SetSyncSource(nil);
  GraphBuilder.SetDefaultSyncSource;
  end;

  VideoPin.QueryInterface(IID_IMPEG2PIDMap, VideoStreamMap);
  AudioPin.QueryInterface(IID_IMPEG2PIDMap,AudioStreamMap);

  Result:=True;
  MediaControl.run;

  Form1.Button2.Enabled:=true;
  Form1.Button4.Enabled:=true;
  end
  else
  Result:=false;
end;
exports StartDVB name 'StartDVB';

procedure StopDVB();stdcall;
begin
  if Assigned(GraphBuilder) then
  begin

  if Assigned(MediaControl) then
     MediaControl.Stop;

   if Assigned(B2C2MPEG2Filter) then
  begin
  B2C2MPEG2TunerCtrl.SetPolarity(POLARITY_LNB_NO_POWER);
  B2C2MPEG2TunerCtrl.SetLnbKHz(LNB_SELECTION_0);
  B2C2MPEG2TunerCtrl.SetTunerStatus ();
  B2C2MPEG2TunerCtrl := nil;
  B2C2MPEG2DataCtrl  := nil;
  B2C2MPEG2Filter := nil;
  end;

   if Assigned(PushSourceFilter) then
  begin
   PushSourceFilter  := nil;
   PushSourceInterface := nil;
  end;

   RemoveGraphFromRot(RotEntry);
   MediaControl := nil;
   VideoWindow:= nil;
   GraphBuilder := nil;
  end;
end;
exports StopDVB name 'StopDVB';

function SetChannel(DiseqC:DWORD;Freq:DWORD; smyb: DWORD; pol: DWORD;fec: DWORD ; lof1 :DWORD; lof2 :DWORD; lofsw :DWORD): BOOL;stdcall;
var
lof:integer;
lnb:integer;
Hr:HRESULT;
begin
   result:=false;
 if assigned(B2C2MPEG2Filter) then begin

 if(freq < lofsw)then
  begin
    lof := lof1;
    lnb := LNB_SELECTION_0;
  end
  else
   begin
     lof := lof2;
     lnb := LNB_SELECTION_22;
   end;
      // B2C2MPEG2TunerCtrl.Initialize;
   hr :=  B2C2MPEG2TunerCtrl.SetDiseqc(DiseqC);
   if FAILED(hr) then  begin  result:=false; exit; end;
 hr :=  B2C2MPEG2TunerCtrl.SetFrequencyKHz(freq);
    if FAILED(hr) then begin  result:=false; exit; end;
 hr :=  B2C2MPEG2TunerCtrl.SetSymbolRate(smyb div 1000);
     if FAILED(hr) then begin  result:=false; exit;  end;
 hr :=  B2C2MPEG2TunerCtrl.SetLnbFrequency(lof div 1000);
    if FAILED(hr) then begin  result:=false; exit; end;
 hr :=  B2C2MPEG2TunerCtrl.SetFec(FEC_AUTO);
     if FAILED(hr) then begin  result:=false; exit; end;
 hr :=  B2C2MPEG2TunerCtrl.SetPolarity(pol);
     if FAILED(hr) then begin  result:=false; exit; end;
 hr :=  B2C2MPEG2TunerCtrl.SetLnbKHz(lnb);
    if FAILED(hr) then begin  result:=false; exit; end;

 hr :=  B2C2MPEG2TunerCtrl.SetTunerStatus();
    if FAILED(hr) then begin  result:=false; exit; end;
 hr :=  B2C2MPEG2TunerCtrl.CheckLock();
     if FAILED(hr) then begin  result:=false; exit; end;

  result:=true;
  end;
end;
exports SetChannel name 'SetChannel';


function SetFilter(wPID:Word;StreamHook: LPCB_STREAMHOOK): Dword; stdcall;
var
hr: HRESULT;
i:integer;
begin
 for i:=0 to MAX_FILTER_COUNT-1  do
    if not Filters[i].Active then
    with Filters[i] do
    begin
      CallBackFunction:=StreamHook;
      PID:=wPID;

      hr:= B2C2MPEG2DataCtrl.AddPIDsToPin(Fcount,@PID,0);
        if (FAILED (hr)) then begin
           Active := FALSE;
           CallBackFunction := nil;
           PID := 0;
           result :=0;
           exit;
           end;
      Active:=True;
      result:=i+1;
      exit;
   end;
  result:=0;
  exit;

end;
exports SetFilter name 'SetFilter';

function DelFilter(FilterID: Dword): BOOL;stdcall;
begin
  if(FilterID > 0) and (FilterID <= MAX_FILTER_COUNT-1) then begin
   if (Filters[FilterID-1].Active)  then
    begin
       Filters[FilterID-1].Active:=False;
       Filters[FilterID-1].CallBackFunction:=nil;
       B2C2MPEG2DataCtrl.DeletePIDsFromPin(Fcount,@Filters[FilterID-1].Pid,0);
       Filters[FilterID-1].Pid:=0;
       Result := True;
       Exit;
    end;
   end;
  Result := false;
end;
exports DelFilter name 'DelFilter';

function GetTunerStatus(Level, Quality: PByte): Bool; stdcall;
var
 hr: HRESULT;
 lSignalStrength: DWord;
 lSignalQuality: DWord;
 fBER: float;
Begin
  lSignalStrength:=0;
  lSignalQuality:=0;
  level^:=0;
  quality^:=0;
  
  if B2C2MPEG2Filter=nil  then begin result:= false; exit;  end;
  if Signal_Quality_Sup  then
  begin
    hr:= B2C2MPEG2TunerCtrl.GetSignalQuality(lSignalQuality);
    if FAILED(hr) then  begin result:=  false; exit; end;
  end;
  if Signal_Strengths_Sup then
  begin
    hr:= B2C2MPEG2TunerCtrl.GetSignalStrength(lSignalStrength);
    if FAILED(hr)  then begin result:= false; exit; end;
    quality^:=BYTE(lSignalStrength);
  end
  else
  if Signal_BER_Sup then
  begin
    fBER:=0.0; 
    hr:= B2C2MPEG2TunerCtrl.GetPreErrorCorrectionBER(fBER,true);
    if FAILED(hr) then begin result:=  false;  exit; end;
  if fBER<10e-7  then quality^:=75
   else
     if fBER<10e-6 then quality^:=50
      else
       if fBER<10e-5
    then
    {*}quality^:=25 
    else
    (* 25%*)
    {*}quality^:=0; 
  end
  (* (Signal.BER >= 10e-2)*)
  (* 0% *)
  else
  {*}quality^:=BYTE(lSignalQuality); 
  if not FAILED(B2C2MPEG2TunerCtrl.CheckLock())
  then
  begin 
    {*}level^:=BYTE(lSignalQuality); 
    if not (Signal_Strengths_Sup and Signal_BER_Sup)
    then
    {*}quality^:=quality^+25;
    begin
      result:= true;
      exit;
    end;
  end
  else
  {*}quality^:=0; 
  begin
    result:=false; 
    exit;
  end;
end;
exports GetTunerStatus name 'GetTunerStatus';



procedure Mpeg2DemultiplexerSetNewPids(VideoPid: Integer; AudioPid: Integer);
var
 MapPid: Cardinal;
begin
  MapPid :=  ActiveVideoPid;
  VideoStreamMap.UnmapPID(1, @MapPid);

  MapPid :=  ActiveAudioPid;
  AudioStreamMap.UnmapPID(1, @MapPid);

   ActiveVideoPid :=VideoPid;
 ActiveAudioPid :=AudioPid;

  MapPid :=  ActiveVideoPid;
  VideoStreamMap.MapPID(1, @MapPid,MEDIA_ELEMENTARY_STREAM);

  MapPid :=  ActiveAudioPid;
  AudioStreamMap.MapPID(1, @MapPid,MEDIA_ELEMENTARY_STREAM);
 end;




initialization
  CoInitialize(nil);

finalization
  CoUnInitialize;
end.
